<template>
  <div class="box-resizer" @mousedown="dragMouseDown"></div>
</template>

<script lang="ts">
  import { Component, Vue } from 'nuxt-property-decorator';
  import config from '~/configs';

  @Component
  export default class Resizer extends Vue {
    private clientX = 0;
    private clientY = 0;

    protected dragMouseDown(event) {
      event.preventDefault();

      this.clientX = event.clientX;
      this.clientY = event.clientY;

      document.onmousemove = this.elementDrag;
      document.onmouseup = this.closeDragElement;
    }

    protected elementDrag(event) {
      event.preventDefault();

      if (this.shouldTriggerEvent(event)) {
        this.$emit('resize', {
          width: this.clientX - event.clientX,
          height: this.clientY - event.clientY,
        });

        this.clientX = event.clientX;
        this.clientY = event.clientY;
      }
    }

    protected shouldTriggerEvent(event)
    {
      return (Math.abs(this.clientX - event.clientX) >= config.gridSize) ||
        (Math.abs(this.clientY - event.clientY) >= config.gridSize)
    }

    protected closeDragElement() {
      document.onmouseup = null;
      document.onmousemove = null;
    };
  }
</script>
